function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import CollectionListener from './utils/CollectionListener';

/**
 * Update callback function
 * @callback CollectionComponent~updateCallback
 * @param {Collection} collection Collection
 * @param {Component} component Component
 * @param {?object} event Collection's event parameters. Null if the callback is triggered by render or setCollection.
 */

/**
 * A generic component wrapper that listens to add/remove events on a collection, calling update on event.
 */
var CollectionComponent = /*#__PURE__*/function () {
  /**
   * Creates a new CollectionComponent instance
   * @param {Collection} [collection] Optional collection object
   * @param {Component} component Component
   * @param {CollectionComponent~updateCallback} update Callback function called on collection events and when component is rendered
   * @param {object} [opt] Optional parameters
   * @param {string} [opt.postrenderUpdate] Flag setting if call to update should be done after render. Defaults to false.
   */
  function CollectionComponent(collection, component, update, opt) {
    _classCallCheck(this, CollectionComponent);
    if (typeof component === 'function') {
      update = component;
      component = collection;
      collection = null;
    }
    this.postrender = !!(opt && opt.postrenderUpdate);
    this.ml = new CollectionListener(collection, component, update);
  }

  /**
   * Set collection
   * If component is rendered, update will be triggered.
   * @param {?Collection} collection Collection
   * @returns {this}
   */
  _createClass(CollectionComponent, [{
    key: "setCollection",
    value: function setCollection(collection) {
      this.ml.setCollection(collection);
      return this;
    }

    /**
     * Gets the current collection
     * @returns {?Collection}
     */
  }, {
    key: "getCollection",
    value: function getCollection() {
      return this.ml.getCollection();
    }

    /**
     * Returns the wrapped component
     * @returns {Component} Wrapped component
     */
  }, {
    key: "getComponent",
    value: function getComponent() {
      return this.ml.component;
    }
  }, {
    key: "render",
    value: function render(el) {
      if (!this.postrender) this.ml.onRender();
      var rel = this.ml.component.render(el);
      if (this.postrender) this.ml.onRender();
      return rel;
    }
  }, {
    key: "unrender",
    value: function unrender() {
      this.ml.component.unrender();
      this.ml.onUnrender();
    }
  }]);
  return CollectionComponent;
}();
export default CollectionComponent;