function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get.bind(); } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }
function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
import { anim } from 'modapp-utils';
import { RootElem } from 'modapp-base-component';

/**
 * A component rendering a list of items based on a collection
 */
var CollectionList = /*#__PURE__*/function (_RootElem) {
  _inherits(CollectionList, _RootElem);
  var _super = _createSuper(CollectionList);
  /**
   * Creates an instance of CollectionList
   * @param {Collection} collection Iterable list of items
   * @param {function} componentFactory  A factory function taking a collection item as argument, returning a component.
   * @param {object} [opt] Optional parameters.
   * @param {string} [opt.tagName] Tag name (eg. 'ul') for the element. Defaults to 'div'.
   * @param {string} [opt.className] Class name
   * @param {object} [opt.attributes] Key/value attributes object
   * @param {object} [opt.events] Key/value events object, where the key is the event name, and value is the callback.
   * @param {string} [opt.subTagName] Tag name (eg. 'li') for the element. Defaults to 'div'.
   * @param {string} [opt.subClassName] A factory function taking a collection item as argument, returning the className for the component.
   * @param {bool} [opt.horizontal] Sets the slide animation to horizontal. Defaults to false.
   * @param {number} [opt.duration] Animation duration in milliseconds.
   */
  function CollectionList(collection, componentFactory, opt) {
    var _this;
    _classCallCheck(this, CollectionList);
    opt = Object.assign({
      tagName: 'div'
    }, opt);
    _this = _super.call(this, opt.tagName, opt);
    _this.collection = null;
    _this.componentFactory = componentFactory;
    _this.subTagName = opt.subTagName || 'div';
    _this.subClassName = opt.subClassName || null;
    _this.animType = opt.horizontal ? 'slideHorizontal' : 'slideVertical';
    _this.duration = opt.duration || null;
    _this.components = null;
    _this.removedComponents = [];
    _this._add = _this._add.bind(_assertThisInitialized(_this));
    _this._remove = _this._remove.bind(_assertThisInitialized(_this));
    _this._rel = null; // Root elements node

    _this.setCollection(collection);
    return _this;
  }

  /**
   * Sets the collection.
   * If the component is rendered, the list will be rerendered with
   * the new collection, without any animation.
   * @param {?Collection} collection Iterable list of items
   * @returns {this}
   */
  _createClass(CollectionList, [{
    key: "setCollection",
    value: function setCollection(collection) {
      collection = collection || null;
      if (collection === this.collection) {
        return this;
      }
      if (!this._rel) {
        this.collection = collection;
        return this;
      }
      this._unrenderComponents();
      this.collection = collection;
      this._renderComponents();
      this._checkSync();
      return this;
    }

    /**
     * Gets the current collection
     * @returns {?Collection}
     */
  }, {
    key: "getCollection",
    value: function getCollection() {
      return this.collection;
    }

    /**
     * Get the component for a model by index
     * @param {number} idx Index if model
     * @returns {?Component} Model component, or null if the list isn't rendered, or if index is out of bounds
     */
  }, {
    key: "getComponent",
    value: function getComponent(idx) {
      if (!this._rel) {
        return null;
      }
      var cont = this.components[idx];
      return cont ? cont.component : null;
    }

    /**
     * Waits for the synchronization of the collection and component list to
     * ensure the collection models matches the rendered components.
     * Calling this method is necessary when calling getComponent after
     * adding/removing items from the collections.
     * Callback will never be called if the CollectionList isn't rendered, or
     * if it unrenders before it has been synchronized.
     * @param {function} callback Callback function called when collection and component list is synchronized.
     */
  }, {
    key: "sync",
    value: function sync(callback) {
      if (!this._rel) {
        return;
      }
      if (this._syncCallbacks) {
        this._syncCallbacks.push(callback);
      } else {
        this._syncCallbacks = [callback];
      }
      this._checkSync();
    }
  }, {
    key: "render",
    value: function render(el) {
      this._rel = _get(_getPrototypeOf(CollectionList.prototype), "render", this).call(this, el);
      this._renderComponents();
      return this._rel;
    }
  }, {
    key: "unrender",
    value: function unrender() {
      this._unrenderComponents();
      this._syncCallbacks = null;
      _get(_getPrototypeOf(CollectionList.prototype), "unrender", this).call(this);
      this._rel = null;
    }
  }, {
    key: "_checkSync",
    value: function _checkSync() {
      // No use checking syncronization if noone cares.
      if (!this._syncCallbacks) {
        return;
      }
      var i = 0,
        comp,
        len = this.components.length;
      var _iterator = _createForOfIteratorHelper(this.collection),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var model = _step.value;
          // More models in the collection than components
          if (i === len) {
            return;
          }
          comp = this.components[i++];
          if (model !== comp.model) {
            return;
          }
        }

        // Do we have more components?
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      if (i !== length) {
        return;
      }

      // We are in sync
      var _iterator2 = _createForOfIteratorHelper(this._syncCallbacks),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var cb = _step2.value;
          cb();
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      this._syncCallbacks = null;
    }
  }, {
    key: "_setSubClassName",
    value: function _setSubClassName(item, li) {
      if (this.subClassName) {
        var className = this.subClassName(item);
        if (className) {
          li.className = className;
        }
      }
    }
  }, {
    key: "_renderComponents",
    value: function _renderComponents() {
      if (!this.collection) {
        return;
      }
      this.components = [];
      var idx = 0;
      var _iterator3 = _createForOfIteratorHelper(this.collection),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var item = _step3.value;
          var component = this.componentFactory(item, idx);
          var li = document.createElement(this.subTagName);
          this.components.push({
            item: item,
            component: component,
            li: li
          });
          this._setSubClassName(item, li);
          this._rel.appendChild(li);
          if (component) {
            component.render(li);
          }
          idx++;
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
      this._setEventListener(true);
    }
  }, {
    key: "_unrenderComponents",
    value: function _unrenderComponents() {
      if (!this.collection) {
        return;
      }
      var _iterator4 = _createForOfIteratorHelper(this.components),
        _step4;
      try {
        for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
          var cont = _step4.value;
          this._removeComponent(cont);
        }
      } catch (err) {
        _iterator4.e(err);
      } finally {
        _iterator4.f();
      }
      this.components = null;
      var _iterator5 = _createForOfIteratorHelper(this.removedComponents),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var _cont = _step5.value;
          this._removeComponent(_cont);
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
      this.removedComponents = [];
      this._setEventListener(false);
    }

    // Callback when the collection have an add event
  }, {
    key: "_add",
    value: function _add(e) {
      // Assert component wasn't unrendered by another event handler
      if (!this._rel) {
        return;
      }
      var item = e.item,
        idx = e.idx;
      var component = this.componentFactory(item, idx);
      var li = document.createElement(this.subTagName);
      var cont = {
        model: item,
        component: component,
        li: li
      };
      this.components.splice(idx, 0, cont);
      this._setSubClassName(item, li);
      li.style.display = 'none';
      // Append last?
      if (this.components.length - 1 === idx) {
        this._rel.appendChild(li);
      } else {
        this._rel.insertBefore(li, this.components[idx + 1].li);
      }
      if (component) {
        component.render(li);
      }
      cont.token = anim[this.animType](li, true, {
        reset: true,
        duration: this.duration
      });
      this._checkSync();
    }

    // Callback when the collection have a remove event
  }, {
    key: "_remove",
    value: function _remove(e) {
      var _this2 = this;
      // Assert component wasn't unrendered by another event handler
      if (!this._rel) {
        return;
      }
      var cont = this.components[e.idx];
      this.components.splice(e.idx, 1);
      this.removedComponents.push(cont);
      anim.stop(cont.token);
      cont.token = anim[this.animType](cont.li, false, {
        callback: function callback() {
          var idx = _this2.removedComponents.indexOf(cont);
          if (idx >= 0) {
            _this2.removedComponents.splice(idx, 1);
            _this2._removeComponent(cont);
          }
        },
        duration: this.duration
      });
      this._checkSync();
    }
  }, {
    key: "_removeComponent",
    value: function _removeComponent(cont) {
      if (!this._rel) {
        return;
      }
      var token = cont.token,
        component = cont.component;
      anim.stop(token);
      if (component) {
        component.unrender();
      }
      this._rel.removeChild(cont.li);
    }
  }, {
    key: "_setEventListener",
    value: function _setEventListener(on) {
      if (this.collection && this.collection.on) {
        if (on) {
          this.collection.on('add', this._add);
          this.collection.on('remove', this._remove);
        } else {
          this.collection.off('add', this._add);
          this.collection.off('remove', this._remove);
        }
      }
    }
  }]);
  return CollectionList;
}(RootElem);
export default CollectionList;