/**
 * Collection of resource components following the component interface of modapp.
 */

import CollectionComponent from './CollectionComponent.js';
import CollectionList from './CollectionList.js';
import CollectionSelect from './CollectionSelect.js';
import ModelButton from './ModelButton.js';
import ModelCheckbox from './ModelCheckbox.js';
import ModelComponent from './ModelComponent.js';
import ModelFragment from './ModelFragment.js';
import ModelHtml from './ModelHtml.js';
import ModelInput from './ModelInput.js';
import ModelList from './ModelList.js';
import ModelRadio, { generateName } from './ModelRadio.js';
import ModelTextarea from './ModelTextarea.js';
import ModelTxt from './ModelTxt.js';
import CollectionListener from './utils/CollectionListener.js';
import ModelListener from './utils/ModelListener.js';

export {
	CollectionComponent,
	CollectionList,
	CollectionSelect,
	ModelButton,
	ModelCheckbox,
	ModelComponent,
	ModelFragment,
	ModelHtml,
	ModelInput,
	ModelList,
	ModelRadio,
	ModelTextarea,
	ModelTxt,
	CollectionListener,
	ModelListener,
	generateName
};
